Index: trunk/Poubelle/archTOI.old/toiiter.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toiiter.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/toiiter.cc	(revision 534)
@@ -2,997 +2,320 @@
 // Eric Aubourg         CEA/DAPNIA/SPP   juillet 1999
 
-#ifndef nb_max_bolo
-#define _archeops		//  Acquisition Archeops (avec transputer) 
-#define programme
-extern "C" {
-#include "archeops.h"
-#include "arcunit.h"
-}
+#include "ark.h"
+
+#include "toiiter.h"
+#include "toimanager.h"
+#include "toiproducer.h"
+#include "archparam.h"
+#include "asigps.h"
+#include "toiauxgpsproducer.h"
+#include <iostream.h>
+#include <fstream.h>
+
+#define CHK_INITED if (initDone) \
+        throw ArchExc("Trying to modify TOIIter after init done.");
+
+TOIIter::TOIIter() {
+  mjdStart = -999999999;
+  mjdEnd   =  999999999;
+  utcStart = -999999999;
+  utcEnd   =  999999999;
+  sStart   = -999999999;
+  sEnd     =  999999999;
+
+  underSample = 1;
+  curSample = -1;
+  
+  initDone = false;
+  incDone  = false;
+}
+
+#ifdef __MWERKS__
+#pragma mark -
 #endif
 
-
-#include "toiiter.h"
-#include "toiinterpolator.h"
-#include "archparam.h"
-#include <dirent.h>
-#include <iostream.h>
-#include "templocator.h"
-
-// Format bloc GPS
-// $GPGGA,hhmmss.ss,ddmm.mmmm,n,dddmm.mmmm,e,q,ss,y.y,a.a,z,
-
-TOIIter::TOIIter() {
- // Toutes les valeurs initialisees par defaut. Le TOISvr les positionnera,
- // puis lancera l'initialisation
+void TOIIter::addDirectory(string dir) {
+  CHK_INITED
+  fset.addDirectory(dir);
+}
+
+void TOIIter::addFile(string fn) {
+  CHK_INITED
+  fset.addFile(fn);
+}
+
+void TOIIter::setMJDInterval(double tStart, double tEnd) {
+  CHK_INITED
+  if (tStart>0) mjdStart = tStart;
+  if (tEnd>0)   mjdEnd = tEnd;
+}
+
+void TOIIter::setUTCInterval(double tStart, double tEnd) {
+  CHK_INITED
+  if (tStart>0) utcStart = tStart;
+  if (tEnd>0)   utcEnd = tEnd;
+}
+
+void TOIIter::setSNInterval(long tStart, long tEnd) {
+  CHK_INITED
+  if (tStart>0) sStart = tStart;
+  if (tEnd>0)   sEnd = tEnd;
+}
+
+void TOIIter::setUnderSample(int n) {
+  CHK_INITED
+  if (n<=1) n=1;
+  underSample = n;
+}
+
+int TOIIter::getUnderSample() {
+  return underSample;
+}
+
+void TOIIter::addTOI(TOI& toi, bool trg) {
+  CHK_INITED
+  TOIProducer* prod = TOIManager::findTOIProducer(toi);
+  if (!prod) throw ArchExc("Cannot produce " + toi.fullName());
+  prod->addTOI(toi, this);
+  request.push_back(TOIInfo(toi,prod,trg?1:0));
+}
+
+#ifdef __MWERKS__
+#pragma mark -
+#endif
+
+
+void TOIIter::registerReqHandler(RequestHandler* h) {
+  CHK_INITED
+  handlers.push_back(h);
+}
+
+
+void TOIIter::readReq(istream& str) {
+  CHK_INITED
+   if (!incDone) defaultInclude();
+   string line;
+   while (str) {
+     getline(str,line);
+     if (!str) break;
+     if (line.substr(0,4)=="#END" && (line.length()==4 || line[5] == ' ')) break;
+     if (line[0] != '@' && line[0] != '#') continue;
+     if (!processRequest(line)) {
+       throw ArchExc("Unrecognized directive " + line);
+     }
+   }
+}
+
+
+bool TOIIter::processRequest(string line) {
+  if (line[0] == '#') {
+    int x = line.find(' ');
+    string keyw = line.substr(0, x);
+    string args = (x>0) ? line.substr(x) : string("");
+    bool handled = processOption(keyw,args);
+    for (list<RequestHandler*>::iterator i = handlers.begin(); 
+	 i != handlers.end(); i++) {
+      handled |= (*i)->processOption(keyw,args);
+    }
+    return handled;
+  }
+
+  if (line[0] == '@') {
+    TOI toi(line.substr(1));
+    // if (kind  == sampleNum || kind == mjd || kind == mutc) notrig = true;
+    bool handled = processTOIReq(toi,line);
+    for (list<RequestHandler*>::iterator i = handlers.begin(); 
+         i != handlers.end(); i++) {
+      handled |= (*i)->processTOIReq(toi,line);
+    }
+    return handled;
+  }
+  return false;
+}
+
+
+bool TOIIter::processTOIReq(TOI& toi,string)
+{
+  TOI toi2 = toi;
+  bool trg=true;
+  if (toi.options.find("notrig") != toi.options.end()) {
+    toi2.options.erase("notrig");
+    trg=false;
+  } 
+  addTOI(toi2, trg);
+  toi.unit = toi2.unit;
+  return true;
+} 
+
+
+bool TOIIter::processOption(string key, string arg)
+{
+  if (arg.length()>0 && arg[0] == ' ') {
+    arg = arg.substr(arg.find_first_not_of(' '));
+  }
+  if (key == "#MJDRANGE") {
+    double tmin, tmax;
+    sscanf(arg.c_str(), "%lg %lg", &tmin, &tmax);
+    setMJDInterval(tmin, tmax);
+  } else if (key == "#UTCRANGE") {
+    double tmin, tmax;
+    sscanf(arg.c_str(), "%lg %lg", &tmin, &tmax);
+    setUTCInterval(tmin, tmax);
+  } else if (key == "#SNRANGE") {
+    long tmin, tmax;
+    sscanf(arg.c_str(), "%ld %ld", &tmin, &tmax);
+    setSNInterval(tmin, tmax);
+  } else if (key == "#PATH") {
+    addDirectory(arg);
+  } else if (key == "#FILE") {
+    addFile(arg);
+  } else if (key == "#UNDERSAMPLE") {
+    setUnderSample(atoi(arg.c_str()));
+  } else if (key == "#MJD0") {
+    double t0;
+    sscanf(arg.c_str(), "%lg", &t0);
+    archParam.acq.tBlock0 = t0;
+  } else if (key == "#UTCORIGIN") {
+    double t0;
+    sscanf(arg.c_str(), "%lg", &t0);
+    archParam.acq.utcOrigin = t0;
+  } else if (key == "#PERECH") {
+    double t0;
+    sscanf(arg.c_str(), "%lg", &t0);
+    archParam.acq.perEch = t0;
+  } else if (key == "#ASIGPS") {
+    ASIGPS* gps = new ASIGPS(arg);
+    TOIManager::registerProducer(new TOIAuxGPSProducer(gps));
+    //    gps->FitsDump("GPSDump.fits");
+  } else if (key == "#INCLUDE") {
+    ifstream f(arg.c_str());
+    readReq(f);
+  } else {
+    return false;
+  }
+  return true;
+}
+
+
+void TOIIter::defaultInclude() {
+  incDone = true;
+  processRequest("#REQVERSION V_270999");
+  processRequest("#MJD0 1376.8358818");
+  processRequest("#PERECH 0.005836818076");
+  processRequest("#UTCORIGIN 1376.5");
+  processRequest("#ASIGPS ASI_GPS_archeops1999.ascii");
+  processRequest("#COMMENT Archtoi V2 -- october 1999 -- Eric Aubourg CEA/DAPNIA");
+  processRequest("#COMMENT ***WARNING***");
+  processRequest("#COMMENT ***SOME TOI'S ARE PRELIMINARY***");
+  processRequest("#COMMENT gyroSpeed is not calibrated");
+  processRequest("#COMMENT azimut/alpha/delta use galaxy crossings and ASI GPS data");
+  processRequest("#COMMENT   and assume no pendulation");
+  processRequest("#COMMENT Focal plane center elevation found at 41.5 deg");
+  processRequest("#COMMENT   with Jupiter");
+  processRequest("#COMMENT boloMuV2 is not protected against glitches");
+}
+
+#ifdef __MWERKS__
+#pragma mark -
+#endif
+
+void TOIIter::init() {
+  if (initDone) return;
+  initDone = true;
  
- file = NULL;
- directory = "";
+  if (utcStart > 0) {
+    double t = (utcStart/24.) + archParam.acq.utcOrigin;
+    if (t > mjdStart) mjdStart=t;
+  }
+  if (utcEnd > 0) {
+    double t = (utcEnd/24.) + archParam.acq.utcOrigin;
+    if (t < mjdEnd) mjdEnd=t;
+  }
+
+  fset.setMJDRange(mjdStart-0.01, mjdEnd+0.01);
+  fset.setSNumRange(sStart-1000, sEnd+1000);
+
+  fset.init();
+  //curSample = fset.getSampleIndex();
+}
+
+bool TOIIter::isTrig(int column) {
+  return (request[column].third & triggering) != 0;
+}
  
- files.clear();
-
- isOnBoardRecorder = false;
-   
- imes=0;
-
- tStart = -9.e99;
- tEnd   = 9.e99;
- utcStart = -9.e99;
- utcEnd   = 9.e99;
- 
- sStart = -999999999;
- sEnd   =  999999999;
- 
- //tBlock0 = -1;
- // perEch = -1;
- // Values for Trapani 99 = default values
- //tBlock0 = 1376.8358818;
- //perEch = 0.005836818076;
- 
- trigMask = 0;
- rawIter = NULL;
- interp  = NULL;
- lastSample = -1;
- maxLookAhead = 10000;
- 
- auxGPS = NULL;
- 
- initDone = false;
- 
- underSample = 1;
-}
-
-TOIIter::TOIIter(TOIIter const& x) {
-  directory = x.directory;
-  files = x.files;
-  if (x.initDone && x.curFile != x.files.end()) curFile = files.find(*(x.curFile));
-  isOnBoardRecorder = x.isOnBoardRecorder;
-  imes   = x.imes;
+TOI TOIIter::getKind(int column) {
+  return request[column].first;
+}
+
+long TOIIter::getSampleNum() {
+  return curSample;
+}
+
+bool TOIIter::next() {
+  if (!initDone) init();
+  for (int ii=0; ii<underSample; ii++)
+    if (!next1()) return false;
   
-  tStart   = x.tStart;
-  tEnd     = x.tEnd;
-  utcStart = x.utcStart;
-  utcEnd   = x.utcEnd;
-  sStart   = x.sStart;
-  sEnd     = x.sEnd;
+  return true;
+}
+
+bool TOIIter::next1() {
+// On tente de produire curSample+1 pour toutes les toi
+// Eventuellement en avancant sur le fichier...
+// Puis on regarde si une TOI triggering a eu une nouvelle
+// valeur.
+// Si on a epuise les fichiers de donnees, on s'arrete des qu'aucune
+// TOI n'a de valeurs apres curSample...
+  if (curSample <= 0) curSample = sStart-1;
+  if (curSample <= 0) curSample = fset.getSampleIndex()-1;
   
-  trigMask = x.trigMask;
-  infos = x.infos;   
-
-  if (x.file)
-    file = new ArcheopsFile(*x.file);
-  else 
-    file = NULL;
-    
-  if (x.rawIter) {
-    rawIter = new TOIIter(*x.rawIter);
-    interp = new TOIInterpolator[infos.size()];
-    for (int i=0; i<infos.size(); i++)
-      interp[i] = x.interp[i];
-  } else {
-    rawIter = NULL;
-    interp  = NULL;
-  }
+  if (curSample >= sEnd || archParam.acq.SN2MJD(curSample) >= mjdEnd) return false;
   
-  lastSample = x.lastSample;
-  maxLookAhead = x.maxLookAhead;
-  
-  auxGPS = x.auxGPS; 
-  if (auxGPS) auxGPS = auxGPS->clone();
-  
-  initDone = x.initDone;
-  underSample = x.underSample;
-}
-
-TOIIter::~TOIIter() {
-  delete file;
-  delete rawIter;
-  delete[] interp;
-  delete auxGPS;
-}
-
-#ifdef __MWERKS__
-#define filesep ':'
-#else
-#define filesep '/'
-#endif
-
-void TOIIter::Init() {
- if (initDone) return;
- initDone = true;
- if (utcStart > 0) {
-   double t = (utcStart/24.) + archParam.acq.utcOrigin;
-   if (t > tStart) tStart=t;
- }
- if (utcEnd > 0) {
-   double t = (utcEnd/24.) + archParam.acq.utcOrigin;
-   if (t < tEnd) tEnd=t;
- }
- // On a soit un repertoire, soit une liste de fichiers....
-  if (directory == "") {
-    if (files.empty()) {   // Ni repertoire, ni fichiers
-      cerr << "toiiter : pas de repertoire, pas de fichiers" << endl;
-      exit(-1);
-    } else {
-      // On a deja une liste de fichiers
+  for (int i=0; i<request.size(); i++)
+    request[i].second->wontNeedEarlier(request[i].first, this, curSample);
+
+  bool endFound = false;
+  while(1) {
+    curSample++;
+    for (vector<TOIInfo>::iterator i = request.begin(); i != request.end(); i++) {
+      while ((*i).second->canGetValueLater(curSample, (*i).first)) {
+        if (! fset.next()) {endFound = true; break;} //return false;
+      }     
     }
-  } else { // On a un repertoire a explorer
-    // On cherche soit les fichiers dans le repertoire donne, soit des fichiers
-    // dans un sous-repertoire "arch-YY_MM_DD". Les fichiers ont un nom en
-    // "hYY_MM_DD-hh_mm_ss".
-    // Pour l'enregistreur de vol, les fichiers ont un nom en ARKxxxxxx.DAT
-    if (directory[directory.length()-1] != filesep) 
-      directory += filesep;
-    DIR* dir = opendir(directory.c_str());
-    struct dirent* ent;
-    while ((ent = readdir(dir)) != NULL) {
-      // si c'est un repertoire, avec un nom de jour, il faut l'explorer...
-      if (!strncmp(ent->d_name, "arch-", 5)) {
-        double mjd = ArcheopsFile::decodeMJD(ent->d_name+5) - 2./24.; // ENTIER + .5 en temps local!
-        if (mjd >= tStart - 1. && mjd <= tEnd) {
-          string direc2 = directory + ent->d_name + filesep;
-          DIR* dir2 = opendir(direc2.c_str());
-          struct dirent* ent2;
-          while ((ent2 = readdir(dir2)) != NULL) {
-            if (*ent2->d_name == 'h') {
-              double mjd2 = ArcheopsFile::decodeMJD(ent->d_name+1) - 2./24.;
-              if (mjd2 >= tStart - 1./24. && mjd2 <= tEnd) {
-                files.insert(direc2 + ent2->d_name);
-              }
-            }
-          }
-        }
-      } else {
-        if (!isOnBoardRecorder && *ent->d_name == 'h') {
-          double mjd = ArcheopsFile::decodeMJD(ent->d_name+1) - 2./24.; // $CHECK$ UTCOffset
-          if (mjd >= tStart - 1./24. && mjd <= tEnd) {
-            files.insert(directory + ent->d_name);
-          }
-        } else if (isOnBoardRecorder) {
-          if (strncmp(ent->d_name, "ARK", 3) && strncmp(ent->d_name, "ark", 3)) continue;
-          char * sfx = ent->d_name + strlen(ent->d_name) - 4;
-          if (strcmp(sfx, ".DAT") && strcmp(sfx, ".dat")) continue;
-          files.insert(directory + ent->d_name);
-        }
-      }
+    bool found=false;
+    bool valuesAhead = false;
+    for (vector<TOIInfo>::iterator i = request.begin(); i != request.end(); i++) {
+      if (((*i).third & triggering) == 0) continue;
+      if ((*i).second->canGetValue(curSample, (*i).first)) {found=true;break;}
+      if ((*i).second->lastSampleNum((*i).first)>curSample) valuesAhead=true;
     }
-    closedir(dir);
-  }
-    
-  ScanFiles();
-  
-  curFile = files.begin();
-  file = new ArcheopsFile((*curFile).c_str());
-  cout << "opening file " << (*curFile).c_str() << endl;
-
-  // On avance jusqu'a avoir au moins un bloc param et un bloc reglage,
-  // car on ne peut rien faire sans...
-  // Si on a des donnees de l'enregistreur de vol, pas de bloc param, et
-  // on en simule un
-  double oldTStart = tStart;
-  tStart = -9.e99; // pour init, on accepte des blocs avant tstart....
-  
-  if (!file->lastParam()) {
-    if (isOnBoardRecorder) {
-      extern param_bolo  parametr;
-      block_type_param block;
-      block.param = parametr;
-      valide_block((block_type_modele*)&block, block_param, 0);
-      file->forceBlock((block_type_modele*)&block);
-    } else {
-      file->nextBlock(block_param_mask);
-    }
-  }
-  if (!file->lastReglage()) file->nextBlock(block_reglage_mask);
-  
-  // On cherche un bloc GPS pour avoir la correspondance timestamp/UTC.
-  // Pour le moment, on se fonde sur le premier bloc GPS. On pourra faire
-  // mieux en prenant le min de tous les delta_T, a condition d'avoir un 
-  // peu plus de details sur la facon dont le GPS est lu.
-  
-  if (archParam.acq.tBlock0 < 0) {
-    archParam.acq.tBlock0 = file->getStartMJD();
-
-    file->pushMark();
-    if (file->lastGPS() || file->nextBlock(block_gps_mask)) {
-      // le temps du bloc courant, en secondes
-      double dt = file->blockNum() * file->perBlock();
-      archParam.acq.tBlock0 = file->getGPSMJD() - dt/86400.;
-    } else { // pas de bloc GPS...
-      archParam.acq.tBlock0 = file->getStartMJD();
-    }
-    file->popMark();
-  }
-  tStart = oldTStart;  // on restaure
-  
-  if (archParam.acq.perEch < 0)
-    archParam.acq.perEch = file->perEchant();
-
-  bool hasInterp = false;
-  
-  trigMask = 0;
-  for (vector<info>::iterator i = infos.begin(); i != infos.end(); i++) {
-    if ((*i).interpolated) hasInterp = true;
-    if ((*i).triggering) {
-      switch ((*i).kind) {
-      case boloMuV:
-      case boloMuV2:
-      case boloRawMuV:
-      case boloRawMuVCN:
-        trigMask |= block_bolo_mask;
-        break;
-      case boloMuV2T:
-      case boloRes:
-      case boloTemp:
-         trigMask |= block_bolo_mask | block_reglage_mask;
-        break;
-      case dilDAC:
-      case dilSwitch:
-        trigMask |= block_dilution_mask;
-      case boloGainAmpli:
-      case boloDACV:
-      case boloDACI:
-        trigMask |= block_reglage_mask;
-        break;
-      case gpsTime:
-      case longitude:
-      case latitude:
-      case altitude:
-        trigMask |= block_gps_mask;
-        break;
-      case azimuthBolo:
-        trigMask |= block_bolo_mask;
-        //file->needSSTProcessMask(SSTHandler::findPeriod);
-        //trigMask |= block_sst_mask;
-        break;
-      case sstStarCnt:
-      case sstStarZ:
-      case sstStarF:
-      case sstStarT:
-        file->needSSTProcessMask(SSTHandler::findStars);
-        trigMask |= block_sst_mask;
-        break;
-      case sstDiode:
-      case sstDiodeCN:
-        file->needSSTProcessMask(SSTHandler::permDiode);
-        trigMask |= block_sst_mask;
-        break;
-      case sstChannel:
-      case sstChannelCN:
-        trigMask |= block_sst_mask;
-        break;
-      case gyroRaw:
-      case gyroV:
-        trigMask |= block_gyro_mask;
-        break;
-      case gyroSpeed:
-        trigMask |= block_gyro_mask; // $CHECK$ + info to calibrate gyros
-        break;
-      case alphaRotAxis:
-      case deltaRotAxis:
-      case alphaSst:
-      case deltaSst:
-      case alphaFPAxis:
-      case deltaFPAxis:
-      case alphaBolo:
-      case deltaBolo:
-        trigMask |= block_bolo_mask;
-        //file->needSSTProcessMask(SSTHandler::findAxis);
-        //trigMask |= block_sst_mask;
-        break;
-      case alphaZenith:
-      case deltaZenith:
-        trigMask |= block_gps_mask;
-        break;
-      case voyantEVO:
-      case voyantEVF:
-      case commandeEV0:
-      case commandeEVF:
-      case commandeEVB:
-      case commandeEVV:
-      case pressEnt3He:
-      case debit3He:
-      case pressSor3He:
-      case pressEnt4He:
-      case debit4He:
-      case pressSor4He:
-      case pressAirVanne:
-      case pressPompChar:
-      case pressMembrane:
-      case pressExterne:
-      case tensPile10T:
-      case tensPileP18D:
-      case tensPileM18D:
-      case tensPile10B:
-      case tensPileP18B:
-      case tensPileM18B:
-      case tensPileCh:
-      case swPile5:
-      case swPile15:
-      case tempCaissH1:
-      case tempCaissH2:
-      case tempCaissB1:
-      case tempCaissB2:
-      case tempCaissTHe:
-      case tempCaissPiles:
-      case tempCaissDrv:
-      case pressHeBain:
-      case pressPirani:
-        trigMask |= block_dilution_mask;
-        break;
-      }
-    }
-  }
-  
-  if (trigMask & (block_bolo_mask | block_sst_mask)) {
-    imes = 9999;
-  } else {
-    imes = 0;
-  }
-  
-  if (hasInterp) {
-    rawIter = new TOIIter(*this);
-    interp = new TOIInterpolator[infos.size()];
-    for (int i=0; i<infos.size(); i++) {
-      rawIter->infos[i].interpolated = false;
-    }
-    delete file; file = NULL; // on ne travaille plus sur le fichier directement...
-  }
-}
-
-void TOIIter::ScanFiles() {
-  file1stSamp.clear();
-  cout << "Scanning all files" << endl;
-  // Petite astuce pour les STL non conformes comme celles de digital
-  // qui ne supportent pas files.erase(i) suivi de i++....
-  set<string> copy = files;
-  for (set<string>::iterator i = copy.begin(); i != copy.end(); i++) {
-    ArcheopsFile fich((*i).c_str());
-    if (fich.nextBlock()) {
-      file1stSamp[*i] = fich.blockNum()*72; // premier numsample
-      cout << "File " << *i << " 1st sample = " << fich.blockNum()*72 << endl;
-    } else {
-      cout << "File " << *i << " unrecoverable, skipping" << endl;
-      files.erase(*i);
-    }
-  }
-  cout << "Scan done" << endl;
-  
-  // Et maintenant, on ne garde que ceux qui tombent dans l'intervalle...
-  copy = files;
-  string prev="";
-  for (set<string>::iterator i = copy.begin(); i != copy.end(); i++) {
-    double smp = file1stSamp[*i];
-    double t   = archParam.acq.tBlock0 + smp * archParam.acq.perEch/86400.;
-    if (t>tEnd || smp>sEnd) {  // premier echantillon apres tEnd
-     files.erase(*i);
-     prev = "";
-     continue;
-    }
-    if (t<tStart || smp<sStart) { // premier echantillon avant tStart -> on vire le precedent si existe
-      if (prev != "") {
-        files.erase(prev);
-      }
-    }
-    prev = *i;
-  }
-}
-
-bool TOIIter::NextFile() {
-  if (rawIter)
-    return rawIter->NextFile();
-    
-  if (files.empty()) {
-    return false;
-  } else {
-    if (curFile == files.end()) return false;
-    curFile++;
-    if (curFile == files.end()) return false;
-    cout << "opening file " << (*curFile).c_str() << endl;
-    ArcheopsFile* newfile = new ArcheopsFile((*curFile).c_str());
-    newfile->grabLastBlocs(*file);
-    delete file;
-    file = newfile;
-    return true;
-  }
-}
-
-bool TOIIter::Next() {
-  for (int ii=0; ii<underSample; ii++)
-    if (!Next1()) return false;
+    if (found) break;
+    if (endFound && !valuesAhead) return false;
+  }
   return true;
 }
 
-bool TOIIter::Next1() {
-  if (!initDone) Init();
-  while (1) {
-    if (!NextSample()) return false; // end of files
-    double t = getMJD();
-    if (t < tStart) continue;
-    if (t > tEnd) return false;
-    return true;
-  }
-}
-
-bool TOIIter::NextSample() {
-  if (rawIter) {  // Delegation pour interpolation
-    // Trouve prochain sample disponible
-    for (int k=0; k<2; k++) {
-      long smp = 2147483647L;
-      for (int i=0; i<infos.size(); i++) {
-        long ss = interp[i].nextSample(lastSample+1);
-        if (ss > 0 && ss < smp) smp=ss;
-      }
-      if (smp != 2147483647L) {
-        lastSample = smp;
-        break;
-      }
-      if (!fetchAhead())  // tout le monde etait en bout de course,
-        return false;     // on lit un echantillon, ca suffit, d'ou le k<2
-    }
-    // Verifie que tous les interpolateurs ont assez de donnees pour
-    // trouver la valeur correspondante
-    for (int i=0; i<infos.size(); i++) {
-      //rif (infos[i].interpolated) 
-        while (interp[i].needMoreDataFor(lastSample) && 
-               rawIter->getSampleIndex() - lastSample < maxLookAhead)
-          if (!fetchAhead()) return false;
-    }
-    
-    // On est pret...
-    return true;
-  }
-
-  // trigger sur info indexee dans bloc bolo, bloc gyro ou bloc sst ?
-  if (trigMask & (block_bolo_mask | block_sst_mask | block_gyro_mask )) {
-    imes++;
-    if (imes < file->nEchBlock()) return true;
-    imes = 0;
-  }
-  
-  // soit pas d'info indexee, soit fin bloc courant...
-  while (1) {
-    if (file->nextBlock(trigMask)) {
-      while (file->sameBlockNumAhead()) {  // tant que meme numero de bloc, on lit
-        if (!file->nextBlock()) {          // fin de fichier ?
-          if (NextFile()) file->nextBlock(); // fichier suivant
-          else return false;    // tout fini
-        }
-      }
-      return true;
-    }
-    if (!NextFile()) return false;
-  }
-}
-
-/* double TOIIter::getTime() {                // MJD 
-   // le temps du bloc courant, en secondes
-   double dt = file->blockNum() * file->perBlock();
-   return tBlock0 + dt/86400. + imes*file->perEchant()/86400.;
- }
- */
- 
+int TOIIter::getColTOI(TOI const& toi) {
+  for (int i=0; i<request.size(); i++)
+    if (request[i].first == toi) return i;
+  throw ArchExc("getColTOI : no such TOI " + toi.name);
+}
+
 bool TOIIter::canGetValue(int column) {
-  if (!initDone) Init();
-   if (column < 0 || column >= infos.size()) return false;
-   TOIKind kind = infos[column].kind;
-   if (auxGPS && 
-       (kind == longitude || kind == latitude || kind == altitude || kind == tsid ||
-        kind == alphaZenith || kind == deltaZenith)) {
-         double dummy;
-         return auxGPS->getLocation(getMJD(), dummy, dummy, dummy) == 0;
-   }
-   if (rawIter) {
-       return interp[column].canGet(lastSample);
-   }
-   int index = infos[column].index;
-   switch (kind) {
-   case sampleNum:
-   case internalTime:
-   case mjd:
-   case mutc:
-     return true;
-   case boloMuV:
-   case boloMuV2:
-   case boloMuV2T:
-   case boloRes:
-   case boloRawMuVCN:
-   case boloTemp:
-     if (imes==0 && file->llastBolo()==NULL) return false;
-     return file->lastBolo() != NULL;
-   case boloRawMuV:
-     return file->lastBolo() != NULL;
-   case boloGainAmpli:
-   case boloDACV:
-   case boloDACI:
-     return file->lastReglage() != NULL;
-   case dilDAC:
-   case dilSwitch:
-     return file->lastDilution() != NULL;
-   case sstDiode:
-   case sstChannel:
-   case sstDiodeCN:
-   case sstChannelCN:
-     return file->lastSST() != NULL;
-   case sstStarCnt:
-   case sstStarZ:
-   case sstStarF:
-   case sstStarT:{
-     if (file->lastSST() == NULL) return false;
-     int n = file->getNumbStar(imes);
-     return (n > 0 && index < n);
-   }
-   case gyroRaw:
-   case gyroV:
-   case gyroSpeed:
-     return (file->lastGyro() != NULL);
-   case gpsTime:
-     return file->hasGPSTime();
-   case longitude:
-   case latitude:
-   case alphaZenith:
-   case deltaZenith:
-     return file->hasGPSPos();
-   case altitude:
-     return file->hasGPSAlt();
-   case tsid:
-     return file->hasGPSPos();
-   case azimuthBolo:
-   case alphaRotAxis:
-   case deltaRotAxis:
-   case alphaFPAxis:
-   case deltaFPAxis:
-   case alphaBolo:
-   case deltaBolo:
-     return true;
-     //return (file->lastGPS() != NULL && file->lastSST() != NULL);
-   case alphaSst:
-   case deltaSst:
-     return false;
-   case voyantEVO:
-   case voyantEVF:
-   case commandeEV0:
-   case commandeEVF:
-   case commandeEVB:
-   case commandeEVV:
-   case pressEnt3He:
-   case debit3He:
-   case pressSor3He:
-   case pressEnt4He:
-   case debit4He:
-   case pressSor4He:
-   case pressAirVanne:
-   case pressPompChar:
-   case pressMembrane:
-   case pressExterne:
-   case tensPile10T:
-   case tensPileP18D:
-   case tensPileM18D:
-   case tensPile10B:
-   case tensPileP18B:
-   case tensPileM18B:
-   case tensPileCh:
-   case swPile5:
-   case swPile15:
-   case tempCaissH1:
-   case tempCaissH2:
-   case tempCaissB1:
-   case tempCaissB2:
-   case tempCaissTHe:
-   case tempCaissPiles:
-   case tempCaissDrv:
-   case pressHeBain:
-   case pressPirani:
-     return file->lastDilution() != NULL;
-   }
-   return false;
-}
-
+   TOIInfo& info = request[column];
+   return(info.second->canGetValue(curSample, info.first));
+}
 
 double TOIIter::getValue(int column) {
-  if (!initDone) Init();
-   if (column < 0 || column >= infos.size()) return -1;
-   TOIKind kind = infos[column].kind;
-   if (auxGPS && 
-       (kind == longitude || kind == latitude || kind == altitude || kind == tsid)) {
-         double lat,lon,alt;
-         if (auxGPS->getLocation(getMJD(), lat, lon, alt)) return -99999;
-         if (kind == longitude) return lon;
-         if (kind == latitude)  return lat;
-         if (kind == altitude)  return alt;
-         if (kind == tsid) {
-           tSid.setLongitude(lon);
-           return tSid.getLST(getMJD());
-         }
-         
-   }
-   if (rawIter) {
-     if (infos[column].interpolated)
-       return interp[column].getIValue(lastSample);
-     else
-       return interp[column].getEValue(lastSample);
-   }
-   int index = infos[column].index;
-   switch (kind) {
-   case sampleNum:
-     return getSampleIndex();
-   case internalTime:
-     return getSampleIndex() * archParam.acq.perEch;
-   case mjd:
-     return getMJD();
-   case mutc:
-     return (getMJD()-archParam.acq.utcOrigin)*24.;
-   case boloMuV:
-     return file->getBoloMuV(index, imes);
-   case boloMuV2:
-     return file->getBoloMuV2(index, imes);
-   case boloRawMuV:
-     return file->getBoloRawMuV(index, imes);
-   case boloRawMuVCN:
-     return file->getBoloRawMuVCN(index, imes);
-   case boloGainAmpli:
-     return file->getGainAmpli(index);
-   case boloDACV:
-     return file->getDACV(index);
-   case boloDACI:
-     return file->getDACI(index);
-   case boloMuV2T:
-     return file->getBoloMuV2T(index, imes);
-   case boloRes:
-     return file->getBoloRes(index, imes);
-   case boloTemp:
-     return file->getBoloTemp(index, imes);
-   case dilDAC:
-     return file->getADCDil(index);
-   case dilSwitch:
-     return file->getSwitchDil();
-   case sstDiode:
-     return file->getSSTSignal(index, imes);
-   case sstChannel:
-     return file->getSSTRawSignal(index, imes);
-   case sstDiodeCN:
-     return file->getSSTSignalCN(index, imes);
-   case sstChannelCN:
-     return file->getSSTRawSignalCN(index, imes);
-   case sstStarCnt:
-     return file->getNumbStar(imes);
-   case sstStarZ:
-     return file->getSSTStarZ(index, imes);
-   case sstStarF:
-     return file->getSSTStarF(index, imes);
-   case sstStarT:
-     return file->getSSTStarT(index, imes);
-   case gyroRaw:
-     return file->getGyroRaw(index, imes);
-   case gyroV:
-     return file->getGyroTens(index, imes);
-   case gyroSpeed:
-     return file->getGyroSpeed(index, imes);
-   case gpsTime:
-     return file->getGPSUTC();
-   case longitude:
-     return file->getGPSLong();
-   case latitude:
-     return file->getGPSLat();
-   case altitude:
-     return file->getGPSAlt();
-   case tsid:
-     tSid.setLongitude(file->getGPSLong());
-     return tSid.getLST(getMJD());
-   case azimuthBolo:
-   case alphaRotAxis:
-   case deltaRotAxis: 
-   case alphaFPAxis:
-   case deltaFPAxis: 
-   case alphaZenith:
-   case deltaZenith: 
-   case alphaBolo:
-   case deltaBolo: {
-        double lat, lon;
-        if (auxGPS) {
-          double alti;
-          auxGPS->getLocation(getMJD(), lat, lon, alti);
-        } else {
-          lon = file->getGPSLong();
-          lat = file->getGPSLat();
-        }
-        tSid.setLongitude(lon);
-        double ts = tSid.getLST(getMJD());
-        tempLocator.setEarthPos(lon, lat);
-        tempLocator.setTSid(ts);
-        if ((kind) == alphaRotAxis) return tempLocator.getAlphaZenith();
-        if ((kind) == deltaRotAxis) return tempLocator.getDeltaZenith();
-        if ((kind) == alphaZenith) return tempLocator.getAlphaZenith();
-        if ((kind) == deltaZenith) return tempLocator.getDeltaZenith();
-        if ((kind) == azimuthBolo) return tempLocator.getAzimutBolo(getSampleIndex(),index);
-        if ((kind) == alphaBolo) return tempLocator.getAlphaBolo(getSampleIndex(),index);
-        if ((kind) == deltaBolo) return tempLocator.getDeltaBolo(getSampleIndex(),index);
-        if ((kind) == alphaFPAxis) return tempLocator.getAlphaCenter(getSampleIndex());
-        if ((kind) == deltaFPAxis) return tempLocator.getDeltaCenter(getSampleIndex());
-        return 0;
-     }
-   case voyantEVO:
-        return voyant_EVO(file->lastDilution());
-   case voyantEVF:
-        return voyant_EVF(file->lastDilution());
-   case commandeEV0:
-        return commande_EVO(file->lastDilution());
-   case commandeEVF:
-        return commande_EVF(file->lastDilution());
-   case commandeEVB:
-        return commande_EVB(file->lastDilution());
-   case commandeEVV:
-        return commande_EVV(file->lastDilution());
-   case pressEnt3He:
-        return pression_entree_3He(file->lastDilution());
-   case debit3He:
-        return debit_3He(file->lastDilution());
-   case pressSor3He:
-        return pression_sortie_3He(file->lastDilution());
-   case pressEnt4He:
-        return pression_entree_4He(file->lastDilution());
-   case debit4He:
-        return debit_4He(file->lastDilution());
-   case pressSor4He:
-        return pression_sortie_4He(file->lastDilution());
-   case pressAirVanne:
-        return pression_air_vanne(file->lastDilution());
-   case pressPompChar:
-        return pression_pompe_charbon(file->lastDilution());
-   case pressMembrane:
-        return pression_membranne(file->lastDilution());
-   case pressExterne:
-        return pression_externe(file->lastDilution());
-   case tensPile10T:
-        return tension_pile_10T(file->lastDilution());
-   case tensPileP18D:
-        return tension_pile_p18D(file->lastDilution());
-   case tensPileM18D:
-        return tension_pile_m18D(file->lastDilution());
-   case tensPile10B:
-        return tension_pile_10B(file->lastDilution());
-   case tensPileP18B:
-        return tension_pile_p18B(file->lastDilution());
-   case tensPileM18B:
-        return tension_pile_m18B(file->lastDilution());
-   case tensPileCh:
-        return tension_pile_Ch(file->lastDilution());
-   case swPile5:
-        return switch_pile_5(file->lastDilution());
-   case swPile15:
-        return switch_pile_15(file->lastDilution());
-   case tempCaissH1:
-        return temperature_caisson_haut1(file->lastDilution());
-   case tempCaissH2:
-        return temperature_caisson_haut2(file->lastDilution());
-   case tempCaissB1:
-        return temperature_caisson_bas1(file->lastDilution());
-   case tempCaissB2:
-        return temperature_caisson_bas2(file->lastDilution());
-   case tempCaissTHe:
-        return temperature_caisson_tube_helium(file->lastDilution());
-   case tempCaissPiles:
-        return temperature_caisson_piles(file->lastDilution());
-   case tempCaissDrv:
-        return temperature_caisson_driver_moteur(file->lastDilution());
-   case pressHeBain:
-        return pression_helium_bain(file->lastDilution());
-   case pressPirani:
-        return pression_pirani(file->lastDilution());
-   }
-   return -1;
-}
- 
-bool   TOIIter::newValue(int column) {
-  if (!initDone) Init();
-   if (column < 0 || column >= infos.size()) return false;
-   TOIKind kind = infos[column].kind;
-   if (auxGPS && 
-       (kind == longitude || kind == latitude || kind == altitude)) {
-      return true;
-   }
-   if (rawIter) {
-       return interp[column].isNewValue(lastSample);
-   }
-   switch (kind) {
-     case sampleNum:
-     case internalTime:
-     case mjd:
-     case mutc:
-     case tsid:
-       return true;
-     case boloMuV:
-     case boloMuV2:
-     case boloMuV2T:
-     case boloRes:
-     case boloTemp:
-       return file->blockNum() == file->getBoloBlockNum();
-     case boloRawMuV:
-     case boloRawMuVCN:
-       return file->blockNum() == file->getBoloBlockNum();
-     case boloGainAmpli:
-       return file->blockNum() == file->getReglageBlockNum() && imes==0;
-     case boloDACI:
-     case boloDACV:
-       return file->blockNum() == file->getReglageBlockNum() && imes==0;
-     case dilDAC:
-     case dilSwitch:
-       return file->blockNum() == file->getDilutionBlockNum() && imes==0;
-     case sstChannel:
-     case sstDiode:
-     case sstStarCnt:
-     case sstStarZ:
-     case sstStarF:
-     case sstStarT:
-       return file->blockNum() == file->getSSTBlockNum();
-     case sstChannelCN:
-     case sstDiodeCN:
-       return file->blockNum() == file->getSSTCompBlockNum();
-     case gyroRaw:
-     case gyroV:
-     case gyroSpeed:
-       return file->blockNum() == file->getGyroBlockNum();
-     case gpsTime:
-       return file->blockNum() == file->getGPSBlockNum() && imes==0;
-     case longitude:
-       return file->blockNum() == file->getGPSBlockNum() && imes==0;
-     case latitude:
-       return file->blockNum() == file->getGPSBlockNum() && imes==0;
-     case altitude:
-       return file->blockNum() == file->getGPSBlockNum() && imes==0;
-     case azimuthBolo:
-     case alphaBolo:
-     case deltaBolo:
-     case alphaZenith:
-     case deltaZenith:
-     case alphaFPAxis:
-     case deltaFPAxis:
-       return true; // $CHECK$ with SSTHandler
-     case alphaRotAxis:
-       return true; // $CHECK$ with SSTHandler
-     case deltaRotAxis:
-       return true; // $CHECK$ with SSTHandler
-     case voyantEVO:
-     case voyantEVF:
-     case commandeEV0:
-     case commandeEVF:
-     case commandeEVB:
-     case commandeEVV:
-     case pressEnt3He:
-     case debit3He:
-     case pressSor3He:
-     case pressEnt4He:
-     case debit4He:
-     case pressSor4He:
-     case pressAirVanne:
-     case pressPompChar:
-     case pressMembrane:
-     case pressExterne:
-     case tensPile10T:
-     case tensPileP18D:
-     case tensPileM18D:
-     case tensPile10B:
-     case tensPileP18B:
-     case tensPileM18B:
-     case tensPileCh:
-     case swPile5:
-     case swPile15:
-     case tempCaissH1:
-     case tempCaissH2:
-     case tempCaissB1:
-     case tempCaissB2:
-     case tempCaissTHe:
-     case tempCaissPiles:
-     case tempCaissDrv:
-     case pressHeBain:
-     case pressPirani:
-       return file->blockNum() == file->getDilutionBlockNum() && imes==0;
-   }
-   return false;
-}
- 
-bool   TOIIter::extendValue(int column) {
-   return (!infos[column].interpolated && !newValue(column));
-}
- 
-bool   TOIIter::interpValue(int column) {
-   return (infos[column].interpolated && !newValue(column));
-}
-
-bool TOIIter::isTrig(int column) {
-   if (column < 0 || column >= infos.size()) return false;
-   return infos[column].triggering;
-}
-
- 
-TOIKind TOIIter::getKind(int column) {
-   if (column < 0 || column >= infos.size()) return (TOIKind)-1;
-   return infos[column].kind;
-}
- 
-int TOIIter::getIndex(int column) {
-   if (column < 0 || column >= infos.size()) return (TOIKind)-1;
-   return infos[column].index;
-}
-
-int TOIIter::getColTOI(TOIKind kind, int index) {
-   for (int i=0; i<infos.size(); i++)
-     if (infos[i].kind == kind && infos[i].index == index)
-       return i;
-   return -1;
-}
-
-bool TOIIter::canGetTOI(TOIKind kind, int index) {
-   int col = getColTOI(kind, index);
-   if (col<0) return false;
-   return canGetValue(col);
-}
-
-double TOIIter::getTOI(TOIKind kind, int index) {
-   int col = getColTOI(kind, index);
-   if (col<0) return -9.e99;
-   return getValue(col);
-}
-
-   
-int TOIIter::getBlockSampleIndex() {
-   return imes;
-}
- 
-int TOIIter::getUnderSampling() {
-  return underSample;
-}
-
-int TOIIter::getSampleIndex() {
-  if (!initDone) Init();
-   if (file) {
-     return file->blockNum() * file->nEchBlock() + imes;
-   } else {
-     return lastSample;
-   }
-}
-
-double TOIIter::getMJD() {
-  if (!initDone) Init();
-  int sample = getSampleIndex();
-  return archParam.acq.tBlock0 + sample*archParam.acq.perEch/86400.;
-}
- 
-bool TOIIter::fetchAhead() { // Seulement si delegation
-  if (!rawIter) return false;
-  if (!rawIter->Next()) return false;
-  long sample = rawIter->getSampleIndex();
-  for (int i=0; i<infos.size(); i++) {
-    if (rawIter->canGetValue(i) && rawIter->newValue(i)) {
-      interp[i].enterValue(rawIter->getValue(i), sample);
-    }
-  }
-  return true;
-}
-
-block_type_param* TOIIter::lastParam() {
-  if (!initDone) Init();
-  if (file) return file->lastParam(); 
-  else return rawIter->lastParam();
-}
-
-
+   TOIInfo& info = request[column];
+   return(info.second->getValue(curSample, info.first));
+}
+
+bool TOIIter::canGetValue(TOI const& toi) {
+  return canGetValue(getColTOI(toi));
+}
+
+double TOIIter::getValue(TOI const& toi) {
+  return getValue(getColTOI(toi));
+}
+
